Index: /trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_OOO_Engine/OOO_Engine/Issue_queue/src/Issue_queue_genMoore.cpp
===================================================================
--- /trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_OOO_Engine/OOO_Engine/Issue_queue/src/Issue_queue_genMoore.cpp	(revision 88)
+++ /trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_OOO_Engine/OOO_Engine/Issue_queue/src/Issue_queue_genMoore.cpp	(revision 88)
@@ -0,0 +1,104 @@
+#ifdef SYSTEMC
+/*
+ * $Id$
+ *
+ * [ Description ]
+ * 
+ */
+
+#include "Behavioural/Core/Multi_OOO_Engine/OOO_Engine/Issue_queue/include/Issue_queue.h"
+
+namespace morpheo                    {
+namespace behavioural {
+namespace core {
+namespace multi_ooo_engine {
+namespace ooo_engine {
+namespace issue_queue {
+
+
+#undef  FUNCTION
+#define FUNCTION "Issue_queue::genMoore"
+  void Issue_queue::genMoore (void)
+  {
+    log_begin(Issue_queue,FUNCTION);
+    log_function(Issue_queue,FUNCTION,_name.c_str());
+
+    for (uint32_t i=0; i<_param->_nb_bank; i++)
+      internal_BANK_OUT_VAL [i] = false;
+
+    std::list<generic::priority::select_t> * select = _priority_out->select(); // same select for all issue
+
+    uint32_t num_bank_offset = 0;
+    for (uint32_t i=0; i<_param->_nb_inst_issue; i++)
+      {
+// 	log_printf(TRACE,Issue_queue,FUNCTION,"  * ISSUE_OUT [%d]",i);
+	Tcontrol_t val      = false;
+	uint32_t   num_bank = 0;
+
+	// find a non empty bank
+	for (std::list<generic::priority::select_t>::iterator it=select->begin();
+	     it!=select->end();
+	     it++)
+	  {
+	    num_bank=num_bank_offset+it->grp;
+	   
+// 	    log_printf(TRACE,Issue_queue,FUNCTION,"    * Bank [%d]",num_bank);
+	    
+	    if (not _issue_queue [num_bank].empty())
+	      {
+// 		log_printf(TRACE,Issue_queue,FUNCTION,"      * Not Empty !!!");
+		val = true;
+
+		internal_BANK_OUT_NUM_INST [num_bank] = i;
+		break; // quit scearch loop
+	      }
+	  }
+
+	PORT_WRITE(out_ISSUE_OUT_VAL [i], val);
+
+	if (val)
+	  {
+	    // have find a bank with a data
+	    internal_BANK_OUT_VAL [num_bank] = true;
+	
+	    entry_t* entry = _issue_queue [num_bank].front();
+	    
+	    if (_param->_have_port_context_id)
+	    PORT_WRITE(out_ISSUE_OUT_CONTEXT_ID            [i], entry->_context_id           );
+	    if (_param->_have_port_front_end_id)
+	    PORT_WRITE(out_ISSUE_OUT_FRONT_END_ID          [i], entry->_front_end_id         );
+	    if (_param->_have_port_rob_ptr  )
+	    PORT_WRITE(out_ISSUE_OUT_PACKET_ID             [i], entry->_packet_id            );
+	    PORT_WRITE(out_ISSUE_OUT_OPERATION             [i], entry->_operation            );
+	    PORT_WRITE(out_ISSUE_OUT_TYPE                  [i], entry->_type                 );
+	    PORT_WRITE(out_ISSUE_OUT_STORE_QUEUE_PTR_WRITE [i], entry->_store_queue_ptr_write);
+	    if (_param->_have_port_load_queue_ptr)
+	    PORT_WRITE(out_ISSUE_OUT_LOAD_QUEUE_PTR_WRITE  [i], entry->_load_queue_ptr_write );
+	    PORT_WRITE(out_ISSUE_OUT_HAS_IMMEDIAT          [i], entry->_has_immediat         );
+	    PORT_WRITE(out_ISSUE_OUT_IMMEDIAT              [i], entry->_immediat             );
+	    PORT_WRITE(out_ISSUE_OUT_READ_RA               [i], entry->_read_ra              );
+	    PORT_WRITE(out_ISSUE_OUT_NUM_REG_RA            [i], entry->_num_reg_ra           );
+	    PORT_WRITE(out_ISSUE_OUT_READ_RB               [i], entry->_read_rb              );
+	    PORT_WRITE(out_ISSUE_OUT_NUM_REG_RB            [i], entry->_num_reg_rb           );
+	    PORT_WRITE(out_ISSUE_OUT_READ_RC               [i], entry->_read_rc              );
+	    PORT_WRITE(out_ISSUE_OUT_NUM_REG_RC            [i], entry->_num_reg_rc           );
+	    PORT_WRITE(out_ISSUE_OUT_WRITE_RD              [i], entry->_write_rd             );
+	    PORT_WRITE(out_ISSUE_OUT_NUM_REG_RD            [i], entry->_num_reg_rd           );
+	    PORT_WRITE(out_ISSUE_OUT_WRITE_RE              [i], entry->_write_re             );
+	    PORT_WRITE(out_ISSUE_OUT_NUM_REG_RE            [i], entry->_num_reg_re           );
+	  }
+
+	num_bank_offset += _param->_nb_bank_select_out;
+      }
+
+    log_end(Issue_queue,FUNCTION);
+  };
+
+}; // end namespace issue_queue
+}; // end namespace ooo_engine
+}; // end namespace multi_ooo_engine
+}; // end namespace core
+
+}; // end namespace behavioural
+}; // end namespace morpheo              
+#endif
Index: /trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_OOO_Engine/OOO_Engine/Issue_queue/src/Issue_queue_statistics_allocation.cpp
===================================================================
--- /trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_OOO_Engine/OOO_Engine/Issue_queue/src/Issue_queue_statistics_allocation.cpp	(revision 88)
+++ /trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_OOO_Engine/OOO_Engine/Issue_queue/src/Issue_queue_statistics_allocation.cpp	(revision 88)
@@ -0,0 +1,103 @@
+#ifdef STATISTICS
+/*
+ * $Id$
+ *
+ * [ Description ]
+ * 
+ */
+
+#include "Behavioural/Core/Multi_OOO_Engine/OOO_Engine/Issue_queue/include/Issue_queue.h"
+
+namespace morpheo {
+namespace behavioural {
+namespace core {
+namespace multi_ooo_engine {
+namespace ooo_engine {
+namespace issue_queue {
+
+
+#undef  FUNCTION
+#define FUNCTION "Issue_queue::statistics_allocation"
+  void Issue_queue::statistics_allocation (morpheo::behavioural::Parameters_Statistics * param_statistics)
+  {
+    log_begin(Issue_queue,FUNCTION);
+
+    _stat = new Stat (static_cast<std::string>(_name),
+		      "Issue_queue",
+		      param_statistics);
+    
+    _stat_bank_nb_inst     = new counter_t * [_param->_nb_bank];
+    _stat_nb_inst_issue_in = new counter_t * [_param->_nb_rename_unit];
+
+    // instruction
+    {
+      _stat_nb_inst_reexecute = _stat->create_variable("nb_inst_reexecute");
+
+      std::string sum_nb_inst_issue_in = "";
+      std::string sum_average_use_interface_issue_in = "";
+      for (uint32_t i=0; i<_param->_nb_rename_unit; i++)
+	{
+	  _stat_nb_inst_issue_in [i] = _stat->create_variable("nb_inst_issue_in_"+toString(i));
+	  
+	  _stat->create_expr_average_by_cycle("average_use_interface_issue_in_"+toString(i), "nb_inst_issue_in_"+toString(i), "", toString(_("Average instruction by cycle on issue_in interface (rename_unit %d)"),i));
+	  _stat->create_expr_percent         ("percent_use_interface_issue_in_"+toString(i) , "average_use_interface_issue_in_"+toString(i), toString(_param->_nb_inst_rename [i]), toString(_("Percent usage of issue_in interface (rename_unit %d)"),i));
+	  
+	  if (i == 0)
+	    {
+	      sum_nb_inst_issue_in               = "nb_inst_issue_in_"+toString(i);
+	      sum_average_use_interface_issue_in = "average_use_interface_issue_in_"+toString(i);
+	    }
+	  else
+	    {
+	      sum_nb_inst_issue_in               = "+ nb_inst_issue_in_"+toString(i) + " " +sum_nb_inst_issue_in;
+	      sum_average_use_interface_issue_in = "+ average_use_interface_issue_in_"+toString(i)+ " "+sum_average_use_interface_issue_in;
+	    }
+      	}
+      
+      _stat->create_expr_average_by_cycle("average_use_interface_reexecute", "nb_inst_reexecute", "", _("Average instruction by cycle on reexecute interface"));
+      _stat->create_expr_percent         ("percent_use_interface_reexecute" , "average_use_interface_reexecute", toString(_param->_nb_inst_reexecute), _("Percent usage of reexecute interface"));
+      
+      _stat->create_expr_average_by_cycle("average_inst_in", "+ nb_inst_reexecute " + sum_nb_inst_issue_in, "", _("Average instruction by cycle"));
+      _stat->create_expr_percent         ("percent_inst_in"          , "average_inst_in"              , toString(_param->_nb_bank), _("Percent of instruction by cycle"));
+      _stat->create_expr_percent         ("percent_inst_reexecute", "average_use_interface_reexecute" , "average_inst_in", _("Percent of instruction reexecute by cycle"));
+      _stat->create_expr_percent         ("percent_inst_issue_in" , sum_average_use_interface_issue_in, "average_inst_in", _("Percent of instruction issue_in by cycle"));
+    }
+    
+    {
+      _stat_nb_inst_issue_out = _stat->create_variable("nb_inst_issue_out");
+
+      _stat->create_expr_average_by_cycle("average_use_interface_issue_out", "nb_inst_issue_out", "", _("Average instruction by cycle on issue_out interface"));
+      _stat->create_expr_percent         ("percent_use_interface_issue_out" , "average_use_interface_issue_out", toString(_param->_nb_inst_issue), _("Percent usage of issue_out interface"));
+    }
+
+    // bank/queue occupation
+    {
+      std::string sum_bank_nb_inst = "";
+      for (uint32_t i=0; i<_param->_nb_bank; i++)
+	{
+	  _stat_bank_nb_inst [i] = _stat->create_variable("bank_nb_inst_"+toString(i));
+	  
+	  _stat->create_expr_average_by_cycle("average_occupation_bank_"+toString(i), "bank_nb_inst_"+toString(i), "", toString(_("Average instruction by cycle (bank %d)"),i));
+	  _stat->create_expr_percent         ("percent_occupation_bank_"+toString(i), "average_occupation_bank_"+toString(i), toString(_param->_size_bank), toString(_("Percent occupation of bank (bank %d)"),i));
+	  
+	  if (i == 0)
+	    sum_bank_nb_inst = "bank_nb_inst_"+toString(i);
+	  else
+	    sum_bank_nb_inst = "+ bank_nb_inst_"+toString(i) + " " +sum_bank_nb_inst;
+	}
+      
+      _stat->create_expr_average_by_cycle("average_occupation_bank", sum_bank_nb_inst, "", _("Average instruction by cycle (all bank)"));
+      _stat->create_expr_percent         ("percent_occupation_bank" , "average_occupation_bank", toString(_param->_size_queue), _("Percent occupation of issue_queue (all bank)"));
+    }
+
+    log_end(Issue_queue,FUNCTION);
+  };
+
+}; // end namespace issue_queue
+}; // end namespace ooo_engine
+}; // end namespace multi_ooo_engine
+}; // end namespace core
+
+}; // end namespace behavioural
+}; // end namespace morpheo              
+#endif
Index: /trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_OOO_Engine/OOO_Engine/Issue_queue/src/Issue_queue_statistics_deallocation.cpp
===================================================================
--- /trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_OOO_Engine/OOO_Engine/Issue_queue/src/Issue_queue_statistics_deallocation.cpp	(revision 88)
+++ /trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_OOO_Engine/OOO_Engine/Issue_queue/src/Issue_queue_statistics_deallocation.cpp	(revision 88)
@@ -0,0 +1,40 @@
+#ifdef STATISTICS
+/*
+ * $Id$
+ *
+ * [ Description ]
+ * 
+ */
+
+#include "Behavioural/Core/Multi_OOO_Engine/OOO_Engine/Issue_queue/include/Issue_queue.h"
+
+namespace morpheo {
+namespace behavioural {
+namespace core {
+namespace multi_ooo_engine {
+namespace ooo_engine {
+namespace issue_queue {
+
+
+#undef  FUNCTION
+#define FUNCTION "Issue_queue::statistics_deallocation"
+  void Issue_queue::statistics_deallocation (void)
+  {
+    log_begin(Issue_queue,FUNCTION);
+
+    log_printf(INFO,Issue_queue,FUNCTION,_("<%s> : Generate Statistics file"),_name.c_str());
+    
+    delete    _stat;
+    delete [] _stat_bank_nb_inst;
+    delete [] _stat_nb_inst_issue_in;
+    log_end(Issue_queue,FUNCTION);
+  };
+
+}; // end namespace issue_queue
+}; // end namespace ooo_engine
+}; // end namespace multi_ooo_engine
+}; // end namespace core
+
+}; // end namespace behavioural
+}; // end namespace morpheo              
+#endif
Index: /trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_OOO_Engine/OOO_Engine/Issue_queue/src/Issue_queue_transition.cpp
===================================================================
--- /trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_OOO_Engine/OOO_Engine/Issue_queue/src/Issue_queue_transition.cpp	(revision 88)
+++ /trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_OOO_Engine/OOO_Engine/Issue_queue/src/Issue_queue_transition.cpp	(revision 88)
@@ -0,0 +1,174 @@
+#ifdef SYSTEMC
+/*
+ * $Id$
+ *
+ * [ Description ]
+ * 
+ */
+
+#include "Behavioural/Core/Multi_OOO_Engine/OOO_Engine/Issue_queue/include/Issue_queue.h"
+
+namespace morpheo                    {
+namespace behavioural {
+namespace core {
+namespace multi_ooo_engine {
+namespace ooo_engine {
+namespace issue_queue {
+
+
+#undef  FUNCTION
+#define FUNCTION "Issue_queue::transition"
+  void Issue_queue::transition (void)
+  {
+    log_begin(Issue_queue,FUNCTION);
+    log_function(Issue_queue,FUNCTION,_name.c_str());
+
+    if (PORT_READ(in_NRESET) == 0)
+      {
+	_priority_in ->reset();
+	_priority_out->reset();
+	_priority_reg->reset();
+	
+	for (uint32_t i=0; i<_param->_nb_bank; i++)
+	  _issue_queue [i].clear();
+      }
+    else
+      {
+	_priority_in ->transition();
+	_priority_out->transition();
+	_priority_reg->transition();
+
+	// ===================================================================
+	// =====[ ISSUE_IN ]==================================================
+	// ===================================================================
+	for (uint32_t i=0; i<_param->_nb_bank; i++)
+	  if (internal_BANK_IN_ACK [i])
+	    {
+	      entry_t* entry = NULL;
+
+	      if (internal_BANK_IN_IS_REEXECUTE [i])
+		{
+		  uint32_t y = internal_BANK_IN_NUM_INST [i];
+	      
+		  if (PORT_READ(in_REEXECUTE_VAL [y]))
+		    {
+#ifdef STATISTICS
+                      if (usage_is_set(_usage,USE_STATISTICS))
+                        (*_stat_nb_inst_reexecute) ++;
+#endif
+		      entry = new entry_t
+			(
+			 (_param->_have_port_context_id    )?PORT_READ(in_REEXECUTE_CONTEXT_ID            [y]):0,
+			 (_param->_have_port_front_end_id  )?PORT_READ(in_REEXECUTE_FRONT_END_ID          [y]):0,
+			 (_param->_have_port_rob_ptr       )?PORT_READ(in_REEXECUTE_PACKET_ID             [y]):0,
+			 PORT_READ(in_REEXECUTE_OPERATION             [y]),
+			 PORT_READ(in_REEXECUTE_TYPE                  [y]),
+			 PORT_READ(in_REEXECUTE_STORE_QUEUE_PTR_WRITE [y]),
+			 (_param->_have_port_load_queue_ptr)?PORT_READ(in_REEXECUTE_LOAD_QUEUE_PTR_WRITE  [y]):0,
+			 PORT_READ(in_REEXECUTE_HAS_IMMEDIAT          [y]),
+			 PORT_READ(in_REEXECUTE_IMMEDIAT              [y]),
+			 PORT_READ(in_REEXECUTE_READ_RA               [y]),
+			 PORT_READ(in_REEXECUTE_NUM_REG_RA            [y]),
+			 PORT_READ(in_REEXECUTE_READ_RB               [y]),
+			 PORT_READ(in_REEXECUTE_NUM_REG_RB            [y]),
+			 PORT_READ(in_REEXECUTE_READ_RC               [y]),
+			 PORT_READ(in_REEXECUTE_NUM_REG_RC            [y]),
+			 PORT_READ(in_REEXECUTE_WRITE_RD              [y]),
+			 PORT_READ(in_REEXECUTE_NUM_REG_RD            [y]),
+			 PORT_READ(in_REEXECUTE_WRITE_RE              [y]),
+			 PORT_READ(in_REEXECUTE_NUM_REG_RE            [y])
+			 );
+		    }
+		}
+	      else
+		{
+		  uint32_t x = internal_BANK_IN_NUM_RENAME_UNIT [i];
+		  uint32_t y = internal_BANK_IN_NUM_INST [i];
+
+		  if (PORT_READ(in_ISSUE_IN_VAL[x][y]))
+		    {
+#ifdef STATISTICS
+                      if (usage_is_set(_usage,USE_STATISTICS))
+                        (*_stat_nb_inst_issue_in [x]) ++;
+#endif
+		      entry = new entry_t
+			(
+			 (_param->_have_port_context_id    )?PORT_READ(in_ISSUE_IN_CONTEXT_ID            [x][y]):0,
+			 (_param->_have_port_front_end_id  )?PORT_READ(in_ISSUE_IN_FRONT_END_ID          [x][y]):0,
+			 (_param->_have_port_rob_ptr       )?PORT_READ(in_ISSUE_IN_PACKET_ID             [x][y]):0,
+			 PORT_READ(in_ISSUE_IN_OPERATION             [x][y]),
+			 PORT_READ(in_ISSUE_IN_TYPE                  [x][y]),
+			 PORT_READ(in_ISSUE_IN_STORE_QUEUE_PTR_WRITE [x][y]),
+			 (_param->_have_port_load_queue_ptr)?PORT_READ(in_ISSUE_IN_LOAD_QUEUE_PTR_WRITE  [x][y]):0,
+			 PORT_READ(in_ISSUE_IN_HAS_IMMEDIAT          [x][y]),
+			 PORT_READ(in_ISSUE_IN_IMMEDIAT              [x][y]),
+			 PORT_READ(in_ISSUE_IN_READ_RA               [x][y]),
+			 PORT_READ(in_ISSUE_IN_NUM_REG_RA            [x][y]),
+			 PORT_READ(in_ISSUE_IN_READ_RB               [x][y]),
+			 PORT_READ(in_ISSUE_IN_NUM_REG_RB            [x][y]),
+			 PORT_READ(in_ISSUE_IN_READ_RC               [x][y]),
+			 PORT_READ(in_ISSUE_IN_NUM_REG_RC            [x][y]),
+			 PORT_READ(in_ISSUE_IN_WRITE_RD              [x][y]),
+			 PORT_READ(in_ISSUE_IN_NUM_REG_RD            [x][y]),
+			 PORT_READ(in_ISSUE_IN_WRITE_RE              [x][y]),
+			 PORT_READ(in_ISSUE_IN_NUM_REG_RE            [x][y])
+			 );
+		    }
+		}
+
+	      if (entry != NULL)
+		_issue_queue [i].push_back(entry);
+	    }
+
+	// ===================================================================
+	// =====[ ISSUE_OUT ]=================================================
+	// ===================================================================
+	for (uint32_t i=0; i<_param->_nb_bank; i++)
+	  {
+// 	    log_printf(TRACE,Issue_queue,FUNCTION,"  * internal_BANK_OUT [%d] val %d, num_inst %d",i,internal_BANK_OUT_VAL [i],internal_BANK_OUT_NUM_INST [i]);
+
+	    if (internal_BANK_OUT_VAL [i])
+	      {
+#ifdef STATISTICS
+                if (usage_is_set(_usage,USE_STATISTICS))
+                  (*_stat_nb_inst_issue_out) ++;
+#endif
+
+		uint32_t x = internal_BANK_OUT_NUM_INST [i];
+// 		log_printf(TRACE,Issue_queue,FUNCTION,"    * ISSUE_OUT_ACK : %d",PORT_READ(in_ISSUE_OUT_ACK [x]));
+		
+		if (PORT_READ(in_ISSUE_OUT_ACK [x]))
+		  {
+		    entry_t * entry =  _issue_queue [i].front();
+		    _issue_queue [i].pop_front();
+		    delete entry;
+		  }
+	      }
+	  }
+      }
+
+    log_printf(TRACE,Issue_queue,FUNCTION,"  * Info Issue_queue");
+    for (uint32_t i=0; i<_param->_nb_bank; i++)
+      {
+#ifdef STATISTICS
+        if (usage_is_set(_usage,USE_STATISTICS))
+          *(_stat_bank_nb_inst [i]) += _issue_queue[i].size();
+#endif
+	log_printf(TRACE,Issue_queue,FUNCTION,"    * [%d] size : %d",i,(int)_issue_queue[i].size());
+      }
+
+#if defined(STATISTICS) or defined(VHDL_TESTBENCH)
+    end_cycle ();
+#endif
+
+    log_end(Issue_queue,FUNCTION);
+  };
+
+}; // end namespace issue_queue
+}; // end namespace ooo_engine
+}; // end namespace multi_ooo_engine
+}; // end namespace core
+
+}; // end namespace behavioural
+}; // end namespace morpheo              
+#endif
Index: /trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_OOO_Engine/OOO_Engine/Issue_queue/src/Issue_queue_vhdl.cpp
===================================================================
--- /trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_OOO_Engine/OOO_Engine/Issue_queue/src/Issue_queue_vhdl.cpp	(revision 88)
+++ /trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_OOO_Engine/OOO_Engine/Issue_queue/src/Issue_queue_vhdl.cpp	(revision 88)
@@ -0,0 +1,48 @@
+#ifdef VHDL
+/*
+ * $Id$
+ *
+ * [ Description ]
+ * 
+ */
+
+#include "Behavioural/Core/Multi_OOO_Engine/OOO_Engine/Issue_queue/include/Issue_queue.h"
+#include "Behavioural/include/Vhdl.h"
+
+namespace morpheo                    {
+namespace behavioural {
+namespace core {
+namespace multi_ooo_engine {
+namespace ooo_engine {
+namespace issue_queue {
+
+
+#undef  FUNCTION
+#define FUNCTION "Issue_queue::vhdl"
+  void Issue_queue::vhdl (void)
+  {
+    log_begin(Issue_queue,FUNCTION);
+
+    Vhdl * vhdl = new Vhdl (_name);
+
+    _interfaces->set_port(vhdl);
+    _component->vhdl_instance(vhdl);
+
+    vhdl_declaration (vhdl);
+    vhdl_body        (vhdl);
+
+    vhdl->generate_file();
+
+    delete vhdl;
+
+    log_end(Issue_queue,FUNCTION);
+  };
+
+}; // end namespace issue_queue
+}; // end namespace ooo_engine
+}; // end namespace multi_ooo_engine
+}; // end namespace core
+
+}; // end namespace behavioural
+}; // end namespace morpheo              
+#endif
Index: /trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_OOO_Engine/OOO_Engine/Issue_queue/src/Issue_queue_vhdl_body.cpp
===================================================================
--- /trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_OOO_Engine/OOO_Engine/Issue_queue/src/Issue_queue_vhdl_body.cpp	(revision 88)
+++ /trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_OOO_Engine/OOO_Engine/Issue_queue/src/Issue_queue_vhdl_body.cpp	(revision 88)
@@ -0,0 +1,35 @@
+#ifdef VHDL
+/*
+ * $Id$
+ *
+ * [ Description ]
+ * 
+ */
+
+#include "Behavioural/Core/Multi_OOO_Engine/OOO_Engine/Issue_queue/include/Issue_queue.h"
+
+namespace morpheo                    {
+namespace behavioural {
+namespace core {
+namespace multi_ooo_engine {
+namespace ooo_engine {
+namespace issue_queue {
+
+
+#undef  FUNCTION
+#define FUNCTION "Issue_queue::vhdl_body"
+  void Issue_queue::vhdl_body (Vhdl * & vhdl)
+  {
+    log_begin(Issue_queue,FUNCTION);
+    vhdl->set_body ("");
+    log_end(Issue_queue,FUNCTION);
+  };
+
+}; // end namespace issue_queue
+}; // end namespace ooo_engine
+}; // end namespace multi_ooo_engine
+}; // end namespace core
+
+}; // end namespace behavioural
+}; // end namespace morpheo              
+#endif
Index: /trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_OOO_Engine/OOO_Engine/Issue_queue/src/Issue_queue_vhdl_declaration.cpp
===================================================================
--- /trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_OOO_Engine/OOO_Engine/Issue_queue/src/Issue_queue_vhdl_declaration.cpp	(revision 88)
+++ /trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_OOO_Engine/OOO_Engine/Issue_queue/src/Issue_queue_vhdl_declaration.cpp	(revision 88)
@@ -0,0 +1,34 @@
+#ifdef VHDL
+/*
+ * $Id$
+ *
+ * [ Description ]
+ * 
+ */
+
+#include "Behavioural/Core/Multi_OOO_Engine/OOO_Engine/Issue_queue/include/Issue_queue.h"
+
+namespace morpheo {
+namespace behavioural {
+namespace core {
+namespace multi_ooo_engine {
+namespace ooo_engine {
+namespace issue_queue {
+
+
+#undef  FUNCTION
+#define FUNCTION "Issue_queue::vhdl_declaration"
+  void Issue_queue::vhdl_declaration (Vhdl * & vhdl)
+  {
+    log_begin(Issue_queue,FUNCTION);
+    log_end(Issue_queue,FUNCTION);
+  };
+
+}; // end namespace issue_queue
+}; // end namespace ooo_engine
+}; // end namespace multi_ooo_engine
+}; // end namespace core
+
+}; // end namespace behavioural
+}; // end namespace morpheo              
+#endif
Index: /trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_OOO_Engine/OOO_Engine/Issue_queue/src/Parameters.cpp
===================================================================
--- /trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_OOO_Engine/OOO_Engine/Issue_queue/src/Parameters.cpp	(revision 88)
+++ /trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_OOO_Engine/OOO_Engine/Issue_queue/src/Parameters.cpp	(revision 88)
@@ -0,0 +1,120 @@
+/*
+ * $Id$
+ *
+ * [ Description ]
+ * 
+ */
+
+#include "Behavioural/Core/Multi_OOO_Engine/OOO_Engine/Issue_queue/include/Parameters.h"
+#include "Common/include/Max.h"
+
+namespace morpheo {
+namespace behavioural {
+namespace core {
+namespace multi_ooo_engine {
+namespace ooo_engine {
+namespace issue_queue {
+
+
+#undef  FUNCTION
+#define FUNCTION "Issue_queue::Parameters"
+  Parameters::Parameters (uint32_t          nb_context              ,
+			  uint32_t          nb_front_end            ,
+			  uint32_t          nb_rename_unit          ,
+			  uint32_t          size_queue              ,
+			  uint32_t          nb_bank                 ,
+			  uint32_t          size_packet             ,
+			  uint32_t          size_general_data       ,
+			  uint32_t          size_special_data       ,
+			  uint32_t          size_general_register   ,
+			  uint32_t          size_special_register   ,
+			  uint32_t          size_store_queue_ptr    ,
+			  uint32_t          size_load_queue_ptr     ,
+			  uint32_t          nb_inst_issue           ,
+			  uint32_t        * nb_inst_rename          ,
+			  uint32_t          nb_inst_reexecute       ,
+			  uint32_t          nb_rename_unit_select   ,
+			  Tpriority_t       priority                ,
+			  Tload_balancing_t load_balancing          ,
+			  bool           ** table_routing           ,
+			  bool           ** table_issue_type        ,
+                          bool              is_toplevel             )
+  {
+    log_begin(Issue_queue,FUNCTION);
+
+    _nb_context               = nb_context           ;
+    _nb_front_end             = nb_front_end         ;
+    _nb_rename_unit           = nb_rename_unit       ;
+    _size_queue               = size_queue           ;
+    _nb_bank                  = nb_bank              ;   
+    _nb_inst_issue            = nb_inst_issue        ;
+    _nb_inst_rename           = nb_inst_rename       ;
+    _nb_inst_reexecute        = nb_inst_reexecute    ;
+    _nb_rename_unit_select    = nb_rename_unit_select;
+    _priority                 = priority             ;
+    _load_balancing           = load_balancing       ;
+    _table_routing            = table_routing        ;
+    _table_issue_type         = table_issue_type     ;
+
+    _max_nb_inst_rename       = max<uint32_t>(_nb_inst_rename,_nb_rename_unit);
+    _nb_bank_select_out       = _nb_bank/nb_inst_issue;
+
+    _size_bank                = _size_queue / _nb_bank;
+    
+    test();
+
+    if (is_toplevel)
+      {
+        _size_context_id          = log2(nb_context  );
+        _size_front_end_id        = log2(nb_front_end);
+        _size_rob_ptr             = size_packet          ;
+        _size_general_data        = size_general_data    ;
+        _size_special_data        = size_special_data    ;
+        _size_general_register    = size_general_register;
+        _size_special_register    = size_special_register;
+        _size_store_queue_ptr     = size_store_queue_ptr ;
+        _size_load_queue_ptr      = size_load_queue_ptr  ;
+        
+        _have_port_context_id     = (_size_context_id     > 0);
+        _have_port_front_end_id   = (_size_front_end_id   > 0);
+        _have_port_rob_ptr        = (_size_rob_ptr        > 0);
+        _have_port_load_queue_ptr = (_size_load_queue_ptr > 0);
+        
+        copy();
+      }
+
+    log_end(Issue_queue,FUNCTION);
+  };
+  
+// #undef  FUNCTION
+// #define FUNCTION "Issue_queue::Parameters (copy)"
+//   Parameters::Parameters (Parameters & param)
+//   {
+//     log_begin(Issue_queue,FUNCTION);
+//     test();
+//     log_end(Issue_queue,FUNCTION);
+//   };
+
+#undef  FUNCTION
+#define FUNCTION "Issue_queue::~Parameters"
+  Parameters::~Parameters (void) 
+  {
+    log_begin(Issue_queue,FUNCTION);
+    log_end(Issue_queue,FUNCTION);
+  };
+
+#undef  FUNCTION
+#define FUNCTION "Issue_queue::copy"
+  void Parameters::copy (void) 
+  {
+    log_begin(Issue_queue,FUNCTION);
+    log_end(Issue_queue,FUNCTION);
+  };
+
+}; // end namespace issue_queue
+}; // end namespace ooo_engine
+}; // end namespace multi_ooo_engine
+}; // end namespace core
+
+}; // end namespace behavioural
+}; // end namespace morpheo              
Index: /trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_OOO_Engine/OOO_Engine/Issue_queue/src/Parameters_msg_error.cpp
===================================================================
--- /trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_OOO_Engine/OOO_Engine/Issue_queue/src/Parameters_msg_error.cpp	(revision 88)
+++ /trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_OOO_Engine/OOO_Engine/Issue_queue/src/Parameters_msg_error.cpp	(revision 88)
@@ -0,0 +1,100 @@
+/*
+ * $Id$
+ *
+ * [ Description ]
+ * 
+ */
+
+#include "Behavioural/include/Types.h"
+#include "Behavioural/Core/Multi_OOO_Engine/OOO_Engine/Issue_queue/include/Parameters.h"
+#include <sstream>
+
+namespace morpheo                    {
+namespace behavioural {
+namespace core {
+namespace multi_ooo_engine {
+namespace ooo_engine {
+namespace issue_queue {
+
+
+#undef  FUNCTION
+#define FUNCTION "Issue_queue::msg_error"
+  Parameters_test Parameters::msg_error(void)
+  {
+    log_begin(Issue_queue,FUNCTION);
+
+    Parameters_test test ("Issue_queue");
+
+    if (not is_multiple(_size_queue, _nb_bank))
+      test.error(toString(_("nb_bank must be a multiple of size_queue.\n")));
+    
+    if (not is_multiple(_nb_bank, _nb_inst_issue))
+      test.error(toString(_("nb_inst_issue must be a multiple of nb_bank.\n")));
+
+    if (_nb_rename_unit_select > _nb_rename_unit)
+      test.error(toString(_("nb_rename_unit_select must be <= nb_rename_unit.\n")));
+
+    if (_size_bank == 1)
+      test.warning(_("For better performance, the bank's size (size_queue/nb_bank) must be > 1.\n"));
+
+    bool type_valid [_nb_type];
+
+    for (uint32_t i=0; i<_nb_type; i++)
+      type_valid [i] = false;
+    
+    type_valid [TYPE_ALU    ] = true;
+    type_valid [TYPE_SHIFT  ] = true;
+    type_valid [TYPE_MOVE   ] = true;
+    type_valid [TYPE_TEST   ] = true;
+    type_valid [TYPE_MUL    ] = true;
+    type_valid [TYPE_DIV    ] = true;
+    type_valid [TYPE_EXTEND ] = true;
+    type_valid [TYPE_FIND   ] = true;
+    type_valid [TYPE_SPECIAL] = true;
+    type_valid [TYPE_CUSTOM ] = true;
+    type_valid [TYPE_BRANCH ] = true;
+    type_valid [TYPE_MEMORY ] = true;
+
+    for (uint32_t i=0; i<_nb_rename_unit; i++)
+      {
+	bool type_present [_nb_type];
+	
+	for (uint32_t j=0; j<_nb_type; j++)
+	  type_present [j] = not type_valid [j];
+
+	bool find = false;
+	for (uint32_t j=0; j<_nb_inst_issue; j++)
+	  if (_table_routing [i][j])
+	  {
+	    find = true;
+
+	    for (uint32_t k=0; k<_nb_type; k++)
+	      type_present [k] |= _table_issue_type [j][k];
+	  }
+
+	if (not find)
+	  test.error(toString(_("Rename_unit [%d] is not connected with a issue slot.\n"),i));
+	else
+	  for (uint32_t j=0; j<_nb_type; j++)
+	    if (not type_present [j])
+	      test.error(toString(_("Rename_unit [%d] can't issue instruction's type \"%s\".\n"),i,toString_type(j).c_str()));
+      }
+    
+    if ((_priority != PRIORITY_ROUND_ROBIN))
+      test.error(toString(_("Unsupported priority scheme (Coming Soon). Supported scheme are : %s.\n"),toString(PRIORITY_ROUND_ROBIN).c_str()));
+    
+    if ((_load_balancing != LOAD_BALANCING_MAXIMUM_FOR_PRIORITY))
+      test.error(toString(_("Unsupported load_balancing scheme (Coming Soon). Supported scheme are : %s.\n"),toString(LOAD_BALANCING_MAXIMUM_FOR_PRIORITY).c_str()));
+
+    log_end(Issue_queue,FUNCTION);
+
+    return test;
+  };
+
+}; // end namespace issue_queue
+}; // end namespace ooo_engine
+}; // end namespace multi_ooo_engine
+}; // end namespace core
+
+}; // end namespace behavioural
+}; // end namespace morpheo              
